<!doctype html>

<html lang="en">

<head>
  <meta charset="utf-8">

  <title>Frontend Features</title>
  <meta name="description" content="Frontend Features">
  <meta name="author" content="Parzi">

</head>

<body>
  <h1>JavaScript examples</h1>
  <h3>Nullish Coalescing operator</h3>
  
  <p>entry || 'default string'</p>
  <button onClick="testOR('some text')">string 'some text'</button>
  <button onClick="testOR('')">empty string ''</button>
  <button onClick="testOR(1)">number 1</button>
  <button onClick="testOR(0)">number 0</button>
  <button onClick="testOR()">nothing</button>
  
  <p>entry ?? 'default string'</p>
  <button onClick="testNullish('some text')">string 'some text'</button>
  <button onClick="testNullish('')">empty string ''</button>
  <button onClick="testNullish(1)">number 1</button>
  <button onClick="testNullish(0)">number 0</button>
  <button onClick="testNullish()">nothing</button>
  
  <h3>Logical Nullish assignment and Logical AND, OR assignment</h3>
  <p>entry object {a:'existing atribute', b: '', c: null}</p>
  <button onClick="testNullishAssignment()">test Nullish assignment</button>
  <button onClick="testLogicalANDAssignment()">test Logical AND assignment</button>
  <button onClick="testLogicalORAssignment()">test Logical OR assignment</button>

  <h3>Optional Chaining</h3>
  <p>entry object {a:'existing atribute', existingFunction: some function}</p>
  <button onClick="noOptionalChaining(chainingObject)">no Optional Chaining</button>
  <button onClick="optionalChaining(chainingObject)">using Optional Chaining</button>

  <h3>Dynamic Import</h3>
  <button onClick="dynamicImport()">execute function</button>
  <script src="js/script.js"></script>
</body>

</html>